import java.io.*;
import java.net.*;
import java.util.*;

class ChatServer {
	public final static int DEFAULT_PORT = 9767;
	public final static char CR = 13;
	public final static char LF = 10;
	protected static int port;
	public static Vector<Participant> presents;
	public static void main(String args[]) {
		ServerSocket server = null;
		presents = new Vector<Participant>();
		Buffer buffer = new Buffer();
		if (args.length >= 1) port = Integer.parseInt(args[0]); else port = DEFAULT_PORT;
		try {
			server = new ServerSocket(port);
		} catch (IOException e) {
			System.err.println("Echec de creation du serveur de discussion sur port " + port);
			System.err.println("  " + e);
			System.exit(1);
		}
		System.out.println("Demarrage du serveur de discussion sur port " + port);
		try {
			Writer writer = new Writer(buffer);
			writer.start();
		} catch (Exception e) {
			System.err.println("Echec de creation du serveur du rapporteur : " + e);
			System.exit(1);
		}
		try {
			while (true) {
				Participant participant = new Participant();
				Socket connection = server.accept();
				participant.address = connection.getInetAddress();
				participant.out = new PrintStream(connection.getOutputStream());
				Listener clientListener = new Listener(connection, participant, buffer);
				clientListener.start();
				participant.listener = clientListener;
				System.out.println("Connexion reussie pour " + participant.name + " " + participant.address);
				ChatServer.presents.addElement(participant);
			}
		} catch(IOException e) {
			System.err.println("Echec de creation d'un client : " + e);
			System.exit(1);
		}
	}
}