import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.net.Socket;

public class Listener extends Thread {
	protected Socket sock;
	protected BufferedReader in;
	protected PrintStream out;
	protected String name;
	protected Buffer buffer;

	public Listener(Socket clientConnection, Participant client, Buffer tampon) {
		String name = new String();
		sock = clientConnection;
		this.buffer = tampon;
		try {
			in = new BufferedReader(new InputStreamReader(sock.getInputStream()));
			out = new PrintStream(sock.getOutputStream());
		} catch (IOException e1) {
			try {
				sock.close();
			} catch (IOException e2) {
			}
			System.err.println("Erreur a la creation d'ecouteur client : " + e1);
			return;
		}
		try { name = in.readLine(); } catch (IOException e) {};
		System.out.println("Tentative de connexion de " + name);
		Participant participant = null;
		for (int i=0; i < ChatServer.presents.size(); i++) {
			participant = (Participant) ChatServer.presents.elementAt(i);
			if (participant.name.equals(name)) break;
		}
		if (participant != null && participant.name.equals(name)) {
			out.print("Il y a un autre utilisateur de ce nom !");
		} else {
			client.name = name;
			this.name = name;
			tampon.write(name + " nous a rejoint !");
			out.println("Bienvenue " + name + ", pour quitter composer '.' et valider.");
		}
	}
	public void run() {
		String text;
		try {
			text = in.readLine();
			while (text != null) {
				System.out.println("echo: " + name + " : " + text);
				if (!text.equals(".")) buffer.write(name + ": " + text);
				text = in.readLine();
			}
			buffer.write(name + " nous quitte !");
		} catch (IOException e1) {}
		finally {
			try { sock.close(); } catch (IOException e2) {}
			System.out.println("Terminaison de l'ecouteur pour " + name);
		}
	}
}
